/*

  File LUtrid.h:

  defines the class LUtrid to solve nxn tridiagonal systems
  through the LU factorization (Thomas's algorithm)

*/


#include "LUvect.h"

#ifndef LUtrid_H

#define LUtrid_H

class LUtrid
{

 private:

   int dim;
   double ** mat;
   double * tmp;

 public:

   LUtrid( int );                                            // Class constructor
   void luFact( );                                           // LU factorization
   void luSolve( LUvect, LUvect );                           // Computes the solution of the system
   void setElement( int, int, double );                      // Defines the matrix through elements
   double getElement( int , int );                           // Returns the i-th, j-th element
   void matVectProduct( LUvect, LUvect );                    // Computes the row by column product of the
                                                             // current matrix times the first argument
                                                             // and stores the result in the second argument
   void duplicateMat( LUtrid );                              // Copy another tridiagonal matrix in the current matrix

};

#endif
